package cl.axg.hls_player;

import android.os.Build;
import android.text.Html;

import androidx.annotation.RequiresApi;

import java.io.UnsupportedEncodingException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
class EPG{
    private String titulo;
    private long horaInicio;
    private long horaFin;
    private int duracion;
    private String siguiente;
    private String anterior;


   public EPG( String titulo, String horaInicio,  String horaFin, String duracion,String anterior, String siguiente){
       this.titulo = titulo;
       this.horaInicio = Long.parseLong(horaInicio);
        this.horaFin =  Long.parseLong(horaFin);
        this.duracion = Integer.parseInt(duracion);
       this.anterior = anterior;
       this.siguiente = siguiente;
    }

    @RequiresApi(api = Build.VERSION_CODES.N)
    public String getTitulo(){
        return this.titulo;
    }


    public long getHoraFin(){
        return  this.horaFin ;
    }
     public String getHoraFinFormato(){
         DateFormat pstFormat = new SimpleDateFormat("HH:mm");

         Date date_fin = new Date(this.horaFin*1000);

        return pstFormat.format(date_fin) ;
     }
     public long getHoraInicio(){
         return  this.horaInicio ;
     }
     public String getHoraInicioFormato(){
         DateFormat pstFormat = new SimpleDateFormat("HH:mm");

         Date date_fin = new Date(this.horaInicio*1000);

         return pstFormat.format(date_fin) ;
     }

     public int getDuracion(){
        return this.duracion;
    }

    public String getSiguiente(){
        return this.siguiente;
    }
    public String getAnterior(){
        return this.anterior;
    }
    public  int getPercentageLeft() {
        Long date= new Date().getTime()/1000;
        float delta = 100*((float)((date-this.horaInicio))/(this.horaFin-this.horaInicio));
        return (int)delta;
       /*
        long now = System.currentTimeMillis();
        Date fecha_now = new Date(now );

        Date fecha_inicio = new Date(Long.parseLong(this.horaInicio + "000") );
        String fecha_inicio_formato =  new java.text.SimpleDateFormat(" k:mm:ss").format(fecha_inicio);


        Date fecha_fin =new Date(Long.parseLong(this.horaFin + "000") );
        String fecha_fin_formato =  new java.text.SimpleDateFormat(" k:mm:ss").format(fecha_fin);

        Date fecha_actual =new Date(System.currentTimeMillis()  );


        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd k:mm:ss");

        Date fechaInicial = dateFormat.parse(new java.text.SimpleDateFormat("yyyy-MM-dd").format(fecha_actual)+fecha_inicio_formato);
        Date fechaFinal = dateFormat.parse(  new java.text.SimpleDateFormat("yyyy-MM-dd").format(fecha_actual)+fecha_fin_formato);
           //  fechaFinal = dateFormat.parse(  dateFormat.format(fechaFinal));
        Date fecha_now1 = dateFormat.parse(  dateFormat.format(fecha_actual));

        if(fechaFinal.getHours()==00){
            fechaFinal.setTime(fecha_fin.getTime()-1000);
        }
        //in milliseconds
        long diff = fechaFinal.getTime() - fecha_now1.getTime();

        long diffSeconds = diff / 1000 % 60;
        long diffMinutes = diff / (60 * 1000) % 60;
        long diffHours = diff / (60 * 60 * 1000) % 24;
        long diffDays = diff / (24 * 60 * 60 * 1000);

       // System.out.print(diffDays + " days, ");
       // System.out.print(diffHours + " hours, ");
       // System.out.print(diffMinutes + " minutes, ");
       // System.out.print(diffSeconds + " seconds.");

       long now1 = fecha_now1.getTime();
        long s = fechaInicial.getTime();
        long e = fechaFinal.getTime();
        if (s >= e || now1 >= e) {
            return 0;
        }
        if (now1 <= s) {
            return 100;
        }
        return 100 - (int) ((e - now1) * 100 / (e - s));
        */
    }

}
