package cl.axg.hls_player;

import com.google.android.gms.cast.framework.CastState;
import com.google.android.gms.cast.framework.IntroductoryOverlay;
import com.google.android.gms.cast.framework.Session;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.mediarouter.app.MediaRouteButton;

import com.google.android.gms.cast.MediaInfo;
import com.google.android.gms.cast.MediaMetadata;
import com.google.android.gms.cast.framework.AppVisibilityListener;
import com.google.android.gms.cast.framework.CastButtonFactory;
import com.google.android.gms.cast.framework.CastContext;
import com.google.android.gms.cast.framework.CastState;
import com.google.android.gms.cast.framework.CastStateListener;
import com.google.android.gms.cast.framework.IntroductoryOverlay;
import com.google.android.gms.cast.framework.Session;
import com.google.android.gms.cast.framework.SessionManagerListener;
import com.google.android.gms.cast.framework.media.RemoteMediaClient;
import com.google.android.gms.common.images.WebImage;

import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;


import androidx.annotation.RequiresApi;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.exoplayer2.DefaultRenderersFactory;
import com.google.android.exoplayer2.ExoPlayer;
import com.google.android.exoplayer2.Player;
import com.google.android.exoplayer2.SimpleExoPlayer;
import com.google.android.exoplayer2.trackselection.DefaultTrackSelector;
import com.google.android.exoplayer2.ui.StyledPlayerView;
import com.google.android.exoplayer2.PlaybackException;
import com.google.android.gms.cast.MediaInfo;
import com.google.android.gms.cast.MediaMetadata;
import com.google.android.gms.cast.framework.AppVisibilityListener;
import com.google.android.gms.cast.framework.CastButtonFactory;
import com.google.android.gms.cast.framework.CastContext;
import com.google.android.gms.cast.framework.CastState;
import com.google.android.gms.cast.framework.CastStateListener;
import com.google.android.gms.cast.framework.IntroductoryOverlay;
import com.google.android.gms.cast.framework.Session;
import com.google.android.gms.cast.framework.SessionManagerListener;
import com.google.android.gms.cast.framework.media.RemoteMediaClient;
import com.google.android.gms.common.images.WebImage;
import com.google.android.exoplayer2.DefaultRenderersFactory;
import com.google.android.exoplayer2.ExoPlaybackException;
import com.google.android.exoplayer2.Player;
import com.google.android.exoplayer2.SimpleExoPlayer;
import com.google.android.exoplayer2.source.MediaSource;
import com.google.android.exoplayer2.source.ProgressiveMediaSource;
import com.google.android.exoplayer2.source.dash.DashMediaSource;
import com.google.android.exoplayer2.source.hls.HlsMediaSource;
import com.google.android.exoplayer2.trackselection.DefaultTrackSelector;
import com.google.android.exoplayer2.ui.PlayerView;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSource;
import com.google.android.exoplayer2.util.Util;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


import android.text.Html;
import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;
import androidx.mediarouter.app.MediaRouteButton;
import java.io.UnsupportedEncodingException;
import java.text.ParseException;
import java.util.ArrayList;
import com.google.android.gms.cast.MediaLoadRequestData;

public class ZappingActivity extends AppCompatActivity implements
        SessionManagerListener,
        AppVisibilityListener,
        CastStateListener {


    private static final String TAG = "ZappingActivity";

    private StyledPlayerView playerView;
    private  ExoPlayer player;
    private  Handler mHandler = new Handler();
    private  Runnable mRunnable;
    private  boolean hayError;
    static  int playVideoAtIndex=0;
    private ImageView btnCloseVideo = null;
    private ImageView btnPreviousVideo = null;
    private ImageView btnNextVideo = null;
    private ImageView btnInfoEPGVideo = null;
    private ImageView btnNextVideoStreaming = null;
    private ImageView btnPreviousVideoStreaming = null;
    private ProgressBar seekBar = null;
    static ArrayList<Video> canales;
    private ArrayList<EPG> epgList ;
    private String urlEPG = null;
    private EPG currentEPG = null;
    private final Common common = new Common();
    private  boolean isSearchingItem;
    private ArrayAdapter<String> mAdapter;

    private IntroductoryOverlay mIntroductoryOverlay;

    private MediaRouteButton mMediaRouteButton;

    public static  Activity activity  ;
    private boolean isVisiblePlayerController = true;


    public void closeImgBtnOnClick(View v)
    {
        this.finish();
    }
    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        if (hasFocus) {
            common.habilitarPreferenciasReproductor(getWindow());
        }
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        common.habilitarVentanaEncendida(getWindow());
        activity = this;
        canales = new ArrayList<Video>();

        Intent intent = getIntent();

        String jsonCanales = intent.getStringExtra("canales");
        isSearchingItem  =   intent.getExtras().getBoolean("isSearchingItem");
        playVideoAtIndex = intent.getIntExtra("playVideoAtIndex",0);
        urlEPG = intent.getStringExtra("urlEPG");

        try {
            JSONArray jsonArray = new JSONArray(jsonCanales);

            for (int i=0; i < jsonArray.length(); i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                int  vivo       =  Integer.parseInt(jsonObject.getString("vivo"));
                String titulo       = jsonObject.getString("titulo");
                String descripcion       = jsonObject.getString("descripcion");
                String   imagenPath  = jsonObject.getString("imagenPath");
                int   numeroCanal  = Integer.parseInt(jsonObject.getString("numeroCanal"));
                int   studio  = Integer.parseInt(jsonObject.getString("studio"));
                String linkReproductor  = jsonObject.getString("linkReproductor");

                final Video video = new Video(vivo, titulo, descripcion, imagenPath,    numeroCanal,   studio,      linkReproductor );

                canales.add(video);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }


        setContentView(R.layout.activity_zapping);
        setUp();

        View controlView = this.findViewById(R.id.playerViewZapping).findViewById(R.id.media_route_button);

        mMediaRouteButton = (MediaRouteButton) controlView.findViewById(R.id.media_route_button);
        CastButtonFactory.setUpMediaRouteButton(getApplicationContext(), mMediaRouteButton);
        CastContext.getSharedInstance(this).addCastStateListener(this);
        CastContext.getSharedInstance(this).addAppVisibilityListener(this);
        CastContext.getSharedInstance(this).getSessionManager().addSessionManagerListener(this);

    }


    public void nextVideoClick(View arg0) 
    {
        buildPlayerChromecast(canales.get(player.getNextMediaItemIndex()));
        player.seekToNext();
    }

    public void previousVideoClick(View arg0)
    {
        buildPlayerChromecast(canales.get(player.getPreviousMediaItemIndex()));
        player.seekToPrevious();
    }
    private void setUp() {

        initializePlayer();
        initControls();
        initEPG();
    }

    private void initializePlayer() {
        playerView = this.findViewById(R.id.playerViewZapping);
        player = common.initPlayer(this, playerView);
        prepareMediaForPlaying(canales.get(player.getCurrentMediaItemIndex()));
        ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
        playPauseVideo.setImageResource(  R.drawable.exo_icon_pause);
        playerView.getVideoSurfaceView().setOnClickListener(view -> {

            if (isVisiblePlayerController) {
                isVisiblePlayerController= false;
                // Do something if controls are visible
                playerView.hideController();


                Log.e("TOUCH", "hideController!");

                if(!isVivo()){
                    View layout_epg = (View)findViewById(R.id.epg);
                    layout_epg.setVisibility(View.VISIBLE);
                    View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                    epg_descripcion.setVisibility(View.VISIBLE);

                }
                View viewControl = (View)findViewById(R.id.viewControl);
                viewControl.setBackgroundColor(Color.TRANSPARENT);


            } else {
                isVisiblePlayerController= true;
                // Do something else if controls are not showing
                playerView.showController();

                View someView = findViewById(R.id.viewControl);
                someView.setBackgroundResource( R.drawable.exoplayer_bottom);

                btnCloseVideo.setVisibility(View.VISIBLE);
                mMediaRouteButton.setVisibility(View.VISIBLE);


                if(!isVivo()){
                    TextView txtDescripcion =  findViewById(R.id.txtDescripcion);
                    txtDescripcion.setVisibility(View.VISIBLE);


                    Video video   = canales.get(playVideoAtIndex);
                    txtDescripcion.setText(video.getDescripcion());

                    View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                    epg_descripcion.setVisibility(View.INVISIBLE);
                    View layout_epg = (View)findViewById(R.id.epg);
                    layout_epg.setVisibility(View.INVISIBLE);
                    btnInfoEPGVideo.setVisibility(View.VISIBLE);
                }else{

                    View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                    epg_descripcion.setVisibility(View.VISIBLE);
                }
                Log.e("TOUCH", "showController!");
            }
        });
        
        player.addListener(new Player.Listener() {
            @Override
            public void onPlayerError(@NonNull PlaybackException error) {
                mHandler.postDelayed(() -> {
                    hayError=true;
                    pause();
                    reproducir();
                }, 1000 * 10);
            }


            @Override
            public void onPlaybackStateChanged(@Player.State int state) {
                if(state==Player.STATE_ENDED){
                    reproducir();
                }
            }
        });

        
        this.reproducir();
    }

    public void pause(){
        player.setPlayWhenReady(false);
        hayError = false;
    }

    public void stop(){
        player.setPlayWhenReady(false);
        player.stop();
        player.seekTo(0);
    }

    public void reproducir(){
        player.setPlayWhenReady(true);
        player.prepare();
        hayError = false;
    }

     void buildPlayerChromecast(Video video){

        if( CastContext.getSharedInstance(this).getSessionManager().getCurrentCastSession() != null
                && CastContext.getSharedInstance(this).getSessionManager().getCurrentCastSession().getRemoteMediaClient() != null ) {

            RemoteMediaClient remoteMediaClient = CastContext.getSharedInstance(this).getSessionManager().getCurrentCastSession().getRemoteMediaClient();

            MediaMetadata metadata = new MediaMetadata(MediaMetadata.MEDIA_TYPE_MOVIE);

            metadata.putString(MediaMetadata.KEY_TITLE, video.getTitulo());
            metadata.putString(MediaMetadata.KEY_SUBTITLE,  video.getNumeroCanal());
            metadata.addImage(new WebImage(Uri.parse(video.getImagenPath())));

            MediaInfo mediaInfo = new MediaInfo.Builder(video.getLinkReproductor())
                    .setStreamType(MediaInfo.STREAM_TYPE_BUFFERED)
                    .setMetadata(metadata)
                    .build();



            assert remoteMediaClient != null;
            remoteMediaClient.load(new MediaLoadRequestData.Builder().setMediaInfo(mediaInfo).build());

        }
    }
    private void prepareMediaForPlaying(Video video) {

        if( CastContext.getSharedInstance(this).getSessionManager().getCurrentCastSession() != null
                && CastContext.getSharedInstance(this).getSessionManager().getCurrentCastSession().getRemoteMediaClient() != null ) {

            buildPlayerChromecast(video);

            this.stop();


        } else {
            for(Video element : canales){
                player.addMediaSource(common.getMediaSource(Uri.parse(element.getLinkReproductor()), this));
            }
            player.setPlayWhenReady(true);
            player.prepare();
       }

    }


    private void releasePlayer() {
        if (player != null) {
            player.release();
            player = null;
        }
    }
    private void pausePlayer() {
        if (player != null) {
            player.setPlayWhenReady(false);
            player.getPlaybackState();
        }
    }
    private void resumePlayer() {
        if (player != null) {
            player.setPlayWhenReady(true);
            player.getPlaybackState();
        }
    }


    public String getURL(){
        return canales.get(playVideoAtIndex).getLinkReproductor();
    }


    public void btnInfoEPGVideoClick(View arg0)
    {
        actualizarEPG();
        View layout_epg = (View)findViewById(R.id.epg);
        layout_epg.setVisibility(View.VISIBLE);
        View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
        txtDescripcion.setVisibility(View.VISIBLE);
        View epg_descripcion = (View)findViewById(R.id.epg_bottom);
        epg_descripcion.setVisibility(View.VISIBLE);

        mMediaRouteButton.setVisibility(View.INVISIBLE);
        btnInfoEPGVideo.setVisibility(View.INVISIBLE);
        btnCloseVideo.setVisibility(View.INVISIBLE);
    }


    public void rewindVideoClick(View arg0)
    {
        player.seekTo(player.getCurrentPosition() - 10000);
    }

    public void playPauseVideoClick(View arg0)
    {
        ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
        playPauseVideo.setImageResource(player.isPlaying() ? R.drawable.exo_icon_play: R.drawable.exo_icon_pause);

        player.setPlayWhenReady(!player.isPlaying());
    }

    public void forwardVideoClick(View arg0)
    {
        player.seekTo(player.getCurrentPosition() + 10000);
    }
    private static String fixEncodingUnicode(String response) {
        String str = "";
        try {
            str = new String(response.getBytes("ISO-8859-1"), "UTF-8");
        } catch (UnsupportedEncodingException e) {

            e.printStackTrace();
        }

        String decodedStr = Html.fromHtml(str).toString();
        return  decodedStr;
    }
    private void actualizarEPG(){

        currentEPG = null;
        Video currentVideo  = canales.get(playVideoAtIndex);
        RequestQueue queue = Volley.newRequestQueue(this);
        String url = urlEPG.replace("STUDIO", String.valueOf(currentVideo.getStudio()));
        Log.d(TAG,"url consulta STUDIO: "+url);

        // Request a string response from the provided URL.
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @RequiresApi(api = Build.VERSION_CODES.N)
                    @Override
                    public void onResponse(String response) {
                        JSONObject jsonObject = null;
                        epgList = new ArrayList<EPG>();
                        TextView txtTitulo =  findViewById(R.id.txtCurrentPrograma);
                        TextView txtProximoTitulo =  findViewById(R.id.txtProximoTitulo);
                        TextView txtHoraInicio =  findViewById(R.id.txtHoraInicio);
                        TextView txtHoraFin =  findViewById(R.id.txtHoraFin);
                        seekBar =  findViewById(R.id.seekbar);
                        seekBar.setProgress(0);
                        try {
                            jsonObject = new JSONObject(fixEncodingUnicode(response));

                            if (jsonObject.has("error")) {
                                Log.e(TAG, "token expirado");
                                return;
                            }

                            if (!jsonObject.has("epg")) {

                                txtTitulo.setText("Programa de "+currentVideo.getTitulo());
                                txtProximoTitulo.setText("Programa de "+currentVideo.getTitulo());
                                txtHoraInicio.setText("00:00");
                                txtHoraFin.setText("00:00");
                                Log.e(TAG, "no se ha encontrado propiedad EPG en JSON");
                                mHandler.removeCallbacks(mUpdateTimeTask);
                                return;
                                //throw new NullPointerException("no se ha encontrado propiedad EPG en JSON ");
                            }else{

                                JSONArray jsonArray = jsonObject.getJSONArray("epg");
                                for (int i=0; i < jsonArray.length(); i++) {
                                    JSONObject item = jsonArray.optJSONObject(i);

                                    EPG epg = new EPG(item.getString("titulo"),item.getString("fecha_ini"),item.getString("fecha_fin"),item.getString("run"),item.getString("anterior"),item.getString("siguiente"));
                                    epgList.add(epg);
                                }
                                if(epgList.size() == jsonArray.length()){


                                    long now = System.currentTimeMillis();
                                    for ( EPG item:epgList )
                                    {
                                        String hora_inicio_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraInicio()  * 1000));
                                        String hora_fin_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraFin()  * 1000));

                                        String hora_actual = new java.text.SimpleDateFormat("kk:mm:ss").format(new java.util.Date());


                                        if(new java.util.Date(item.getHoraInicio()  * 1000).before(new java.util.Date()) &&  new java.util.Date().after(new java.util.Date(item.getHoraFin()  * 1000))){

                                        }else{

                                            System.out.println("PROGRAMA MENOR ACTUAL HORA2: "+item.getTitulo());
                                            currentEPG = item;
                                            break;
                                        }
                                    }

                                    if(currentEPG != null){
                                        updateProgressBar();
                                        txtTitulo.setText(currentEPG.getTitulo());
                                        txtProximoTitulo.setText(currentEPG.getSiguiente());
                                        txtHoraInicio.setText(currentEPG.getHoraInicioFormato());
                                        txtHoraFin.setText(currentEPG.getHoraFinFormato());

                                    }else{
                                                                           txtTitulo.setText("Programa de "+currentVideo.getTitulo());
                                        txtProximoTitulo.setText("Programa de "+currentVideo.getTitulo());
                                        txtHoraInicio.setText("00:00");
                                        txtHoraFin.setText("00:00");
                                        Log.e(TAG, "Current EPG is null: "+url);
                                        mHandler.removeCallbacks(mUpdateTimeTask);
                                        return;
                                    }
                                }
                            }

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d(TAG, "That didn't work!"+error.toString());
            }
        });

        // Add the request to the RequestQueue.
        queue.add(stringRequest);
    }
    /**
     * Update timer on seekbar
     * */
    public void updateProgressBar() {
        mHandler.postDelayed(mUpdateTimeTask, 100);
    }

    /**
     * Background Runnable thread
     * */
    private Runnable mUpdateTimeTask = new Runnable() {
        public void run() {

            int valor = 0;
            try {
                valor = currentEPG.getPercentageLeft();
            } catch (Exception e) {
                e.printStackTrace();
            }
            seekBar.setProgress( valor );
            Log.d("PROGRESO","progreso es: "+valor);

            // Running this thread after 100 milliseconds
            mHandler.postDelayed(this, 100);
        }
    };



    /**
     * When user starts moving the progress handler
     * */

    private void  initEPG(){
        Video video   = canales.get(playVideoAtIndex);

        new DownloadImageTask(findViewById(R.id.imgCanal))
                .execute(video.getImagenPath());

        TextView txtNumeroCanal =  findViewById(R.id.txtNumeroCanal);
        TextView txtTituloCanal =  findViewById(R.id.txtTituloCanal);
        TextView txtDescripcion =  findViewById(R.id.txtDescripcion);

        Log.d(TAG, "current video: "+video.getTitulo());
        Log.d(TAG, "current video: "+video.getNumeroCanal());
        Log.d(TAG, "current video: "+video.getDescripcion());
        txtNumeroCanal.setText(video.getNumeroCanal());
        txtTituloCanal.setText(video.getTitulo());
        txtDescripcion.setText(video.getDescripcion());
    }
    private Boolean isVivo(){
        return canales.get(playVideoAtIndex).getIsVivo();
    }
    private void HideControlPreviousNextWhenIsSearchingItem(){

        if(isSearchingItem){
            btnPreviousVideo.setVisibility(View.INVISIBLE);
            btnNextVideo.setVisibility(View.INVISIBLE);
            btnPreviousVideoStreaming.setVisibility(View.INVISIBLE);
            btnNextVideoStreaming.setVisibility(View.INVISIBLE);
        }
    }
    private void initControls(){
        LinearLayout linearLayoutVOD =  findViewById(R.id.linearLayoutVOD);
        LinearLayout linearLayoutStreaming =  findViewById(R.id.linearLayoutStreaming);
        LinearLayout linearLayoutEPG =  findViewById(R.id.epg);
        btnCloseVideo = findViewById(R.id.btnCloseVideo);
        btnPreviousVideo = findViewById(R.id.btnPreviousVideoVOD);
        btnNextVideo = findViewById(R.id.btnNextVideoVOD);
        btnPreviousVideoStreaming = findViewById(R.id.btnPreviousVideoStreaming);
        btnNextVideoStreaming = findViewById(R.id.btnNextVideoStreaming);

        if (isVivo()){

            ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
            playPauseVideo.setImageResource( R.drawable.exo_icon_pause);//isPlaying ? R.drawable.exo_icon_pause:
            linearLayoutVOD.setVisibility(View.VISIBLE);
            linearLayoutStreaming.setVisibility(View.INVISIBLE);
            linearLayoutEPG.setVisibility(View.INVISIBLE);
        }else{

            linearLayoutVOD.setVisibility(View.INVISIBLE);
            linearLayoutStreaming.setVisibility(View.VISIBLE);
            linearLayoutEPG.setVisibility(View.INVISIBLE);
            View epg_descripcion = (View)findViewById(R.id.epg_bottom);
            epg_descripcion.setVisibility(View.INVISIBLE);
            View viewControl = (View)findViewById(R.id.viewControl);
            viewControl.setBackgroundColor(Color.TRANSPARENT);

            btnInfoEPGVideo = findViewById(R.id.btnInfoEPGVideo);
        }
        HideControlPreviousNextWhenIsSearchingItem();

    }
    @Override
    protected void onPause() {
        super.onPause();
        pausePlayer();
        if (mRunnable != null) {
            mHandler.removeCallbacks(mRunnable);
        }
    }
    @Override
    protected void onRestart() {
        super.onRestart();
        resumePlayer();
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        releasePlayer();
        CastContext.getSharedInstance(this).removeAppVisibilityListener(this);
        CastContext.getSharedInstance(this).removeCastStateListener(this);
        CastContext.getSharedInstance(this).getSessionManager().removeSessionManagerListener(this);
    }
    private void showIntroductoryOverlay() {
        if (mIntroductoryOverlay != null) {
            mIntroductoryOverlay.remove();
        }
        if ((mMediaRouteButton != null) ) {
            new Handler().post(new Runnable() {
                @Override
                public void run() {
                    mIntroductoryOverlay = new IntroductoryOverlay.Builder(
                            ZappingActivity.this, mMediaRouteButton)
                            .setTitleText("Selecciona tu dispositivo")
                            .setOverlayColor(R.color.colorPrimary)
                            .setSingleTime()
                            .setOnOverlayDismissedListener(
                                    new IntroductoryOverlay.OnOverlayDismissedListener() {
                                        @Override
                                        public void onOverlayDismissed() {
                                            mIntroductoryOverlay = null;
                                        }
                                    })
                            .build();
                    mIntroductoryOverlay.show();
                }
            });
        }
    }

    @Override
    public void onSessionStarting(Session session) {
        Log.e("Tuts+", "onSessionsStarting");
    }

    @Override
    public void onSessionStarted(Session session, String s) {
        Log.e("Tuts+", "onSessionStarted");
        invalidateOptionsMenu();
    }

    @Override
    public void onSessionStartFailed(Session session, int error) {
        int castReasonCode = CastContext.getSharedInstance(this).getCastReasonCodeForCastStatusCode(error);
        Log.e("Tuts+", "onSessionStartFailed");
    }

    @Override
    public void onSessionEnding(Session session) {
        Log.e("Tuts+", "onSessionEnding");
    }

    @Override
    public void onSessionEnded(Session session, int i) {
        Log.e("Tuts+", "onSessionEnded");
        this.reproducir();
    }

    @Override
    public void onSessionResuming(Session session, String s) {
        Log.e("Tuts+", "onSessionResuming");
    }

    @Override
    public void onSessionResumed(Session session, boolean b) {
        Log.e("Tuts+", "onSessionResumed");
        invalidateOptionsMenu();
    }

    @Override
    public void onSessionResumeFailed(Session session, int i) {
        Log.e("Tuts+", "onSessionResumeFailed");
    }

    @Override
    public void onSessionSuspended(Session session, int i) {
        Log.e("Tuts+", "onSessionSuspended");
    }

    @Override
    public void onAppEnteredForeground() {
        Log.e("Tuts+", "onAppEnteredForeground");
    }

    @Override
    public void onAppEnteredBackground() {
        Log.e("Tuts+", "onAppEnteredBackground");
    }

    @Override
    public void onCastStateChanged(int newState) {
        Log.e("Tuts+", "onCastStateChanged");

        Log.e("Tuts+", String.valueOf(CastState.CONNECTED));
        switch( newState ) {
            case CastState.CONNECTED: {
                prepareMediaForPlaying(canales.get(player.getCurrentMediaItemIndex()));
                break;
            } case CastState.CONNECTING: {

                break;
            } case CastState.NOT_CONNECTED: {

                break;
            } case CastState.NO_DEVICES_AVAILABLE: {

            }
        }

        if (newState != CastState.NO_DEVICES_AVAILABLE) {
          //  showIntroductoryOverlay();
        }
    }


    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        // ignore orientation/keyboard change
        super.onConfigurationChanged(newConfig);
    }

    @Override
    public void onBackPressed() {
        Log.d("CDA", "onBackPressed Called");
        super.onBackPressed();
    }

}